import tseslint from 'typescript-eslint'

/** @type {import('typescript-eslint').Config} */
export default tseslint.config(
    ...tseslint.configs.recommendedTypeChecked,
    ...tseslint.configs.stylisticTypeChecked,
    {
        files: ['**/*.ts', '**/*.tsx', '**/*.cts', '**/*.mts'],
        languageOptions: {
            parser: tseslint.parser,
            parserOptions: {
                ecmaVersion: 'latest',
                project: ['./tsconfig.json', './tsconfig.eslint.json'],
            },
        },
        rules: {
            'no-shadow': 'off',
            '@typescript-eslint/no-shadow': 'error',

            '@typescript-eslint/consistent-type-definitions': ['error', 'type'],

            'jsdoc/require-jsdoc': 'off',
        },
    },
    {
        // disable type-aware linting on JS files
        files: ['**/*.js'],
        ...tseslint.configs.disableTypeChecked,
    },
)
